#include <windows.h>
#include <commctrl.h>
#ifndef INITCOMMONCONTROLSEX
typedef struct {
	DWORD dwSize;
	DWORD dwICC;
} INITCOMMONCONTROLSEX,*LPINITCOMMONCONTROLSEX;
#endif
#ifndef InitCommonControlsEx
int WINAPI InitCommonControlsEx(LPINITCOMMONCONTROLSEX);
#endif
HANDLE DOSBOX_HANDLE = 0;
long pid;
int scanning=0;
#include "offsets074.h"
#include "ccodes.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define ABOUT_BTN 1001
#define SYS_TAB32 1002
#define ATTACH_TO_DOSBOX_BTN 1003
#define BASE_ADDR_BOX 1004
#define PATH_BOX 1005
#define NAME_BOX 1006
#define CODE_START_BOX 1007

#define SCAN_VIEW 2001
#define SCAN_PERC 2002
#define SCAN_COUNT 2003
#define SCAN_DTYPE 2004
#define SCAN_EDITABLE 2005
#define NEW_SCAN 2006
#define SCAN_EXACT_INIT 2007
#define SCAN_UNKNOWN_INIT 2008
#define SCAN_EXACT 2009
#define SCAN_UNCHANGED 2010
#define SCAN_CHANGED 2011
#define SCAN_GREATER_THAN 2012
#define SCAN_LESS_THAN 2013
#define SCAN_INCREASED_THAN 2014
#define SCAN_DECREASED_THAN 2015
#define ADD_TO_CODELIST 2016

#define CODE_LIST 3001
#define ADD_CODE 3002
#define DEL_CODE 3003
#define OPEN_F_CODE 3004
#define SAVE_F_CODE 3005
#define ACTIV_CODE 3006
#define DEACTIV_CODE 3007

#define MEM_VIEW 4001
#define REFRESH_MEM_VIEW 4002
#define NEXT_MEM_VIEW 4003
#define PREV_MEM_VIEW 4004
#define PAGE_MEM_VIEW 4005

#define ADD_CODE_NAME 6001
#define ADD_CODE_CODE 6002
#define OK_ADD_CODE_NAME 6003
#define CANCEL_ADD_CODE_NAME 6004

#define CREATE_CODE_NAME 7001
#define CREATE_CODE_SIZE 7002
#define CREATE_CODE_OFFSET 7003
#define CREATE_CODE_VALUE 7004
#define CANCEL_CREATE_CODE 7005
#define OK_CREATE_CODE 7006


HWND dosbox_hwnd;
HINSTANCE hInstance;
HICON hIcon;
HICON hIconSm;

#define Disable(hwnd,id)(EnableWindow(GetDlgItem(hwnd,id),0))
#define Enable(hwnd,id)(EnableWindow(GetDlgItem(hwnd,id),1))


HWND dosbox_hwnd_tab = 0;
HWND scanner_hwnd_tab;
HWND codes_hwnd_tab;
HWND memview_hwnd_tab;
HWND about_hwnd_tab;


static int attached = 0;
dshark_074_off inject_074;

int memview_page=0;
char buf[99];



int __FindDOSBOX_callback(HWND wnd, LPARAM lparam)
{
	char wndtext[13];
	memset(wndtext,0,13);
	GetWindowText(wnd,wndtext,12);
	if(strcmp(TITLE_TEXT_074,wndtext) == 0)
	{
		dosbox_hwnd=wnd;
		return 0;
	}
	
	return 1;
}

int FindDOSBOX(void)
{
	dosbox_hwnd=0;
	EnumWindows((void*)__FindDOSBOX_callback,0);
	if(!dosbox_hwnd)
	{
		return 0;
	}
	
	GetWindowThreadProcessId(dosbox_hwnd,&pid);
	DOSBOX_HANDLE = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pid);
	if(!DOSBOX_HANDLE)
	{
		return 0;
	}
	return 1;
}

int SubFindDOSBOX(void)
{
	dosbox_hwnd=0;
	EnumWindows((void*)__FindDOSBOX_callback,0);
	if(!dosbox_hwnd)
	{
		return 0;
	}
	return 1;
}

int __thread_update_info_074(void * a)
{
	char sbuf[25];
	init074(&inject_074);
	reload074(&inject_074);
	sprintf(sbuf,"0x%.8x",inject_074.base);
	SetDlgItemText(dosbox_hwnd_tab,BASE_ADDR_BOX,sbuf);
	sprintf(sbuf,"0x%.8x",inject_074.start);
	SetDlgItemText(dosbox_hwnd_tab,CODE_START_BOX,sbuf);
	while(attached)
	{
		reload074(&inject_074);
		SetDlgItemText(dosbox_hwnd_tab,PATH_BOX,inject_074.path);
		SetDlgItemText(dosbox_hwnd_tab,NAME_BOX,inject_074.name);
		
		Sleep(500);
	}
	return 1;
}


void TempScanClean(void)
{
	remove("scan.tmp");
	remove("scan2.tmp");
}

int load_ccode(ccode* code, char* str)
{
	return sscanf(str,"%1X%6X%X",&code->size,&code->offset,&code->value);
}

void save_ccode(ccode* code, char* str)
{
	sprintf(str,"%.1X%.6X%X",code->size,code->offset,code->value);
}

void ToggleCode(int onoff)
{
	HWND hwnd = GetDlgItem(codes_hwnd_tab,CODE_LIST);
	int id=SendMessage(hwnd,LB_GETCARETINDEX,0,0);
	int max=SendMessage(hwnd,LB_GETCOUNT,0,0);
	int i;
	SendMessage(hwnd,WM_SETREDRAW,0,0);
	int gc1 = SendMessage(hwnd,LB_GETCURSEL,0,0);
	for(i=0;i<max;++i)
	{
		SendMessage(hwnd,LB_GETTEXT,0,(LPARAM)buf);
		
		if(i==id)
		{
			if(onoff)
			{
				buf[1]='O';
			}
			else
			{
				buf[1]='X';
			}
		}
		
		SendMessage(hwnd,LB_DELETESTRING,0,0);
		SendMessage(hwnd,LB_ADDSTRING,0,(LPARAM)buf);
	}
	SendMessage(hwnd,LB_SETCURSEL,gc1,0);
	SendMessage(hwnd,WM_SETREDRAW,1,0);
}


LRESULT CALLBACK AddCodeDlgProc(HWND hWndDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{	
	if(Msg == WM_INITDIALOG)
	{
		RECT rct;
		GetWindowRect(hWndDlg,&rct);
		SetWindowPos(hWndDlg,0,(GetSystemMetrics(SM_CXSCREEN)/2)-((rct.right-rct.left)/2),(GetSystemMetrics(SM_CYSCREEN)/2)-((rct.bottom-rct.top)/2),0,0,SWP_NOSIZE|SWP_NOZORDER);
		
		sprintf(buf,"%i",SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_GETCURSEL,0,0)+1);
		SetDlgItemText(hWndDlg,CREATE_CODE_SIZE,buf);
		memset(buf,0,99);
		SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),LB_GETTEXT,SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),LB_GETCARETINDEX,0,0),(LPARAM)buf);
		buf[8]=0;
		SetDlgItemText(hWndDlg,CREATE_CODE_OFFSET,buf);
		SetDlgItemText(hWndDlg,CREATE_CODE_VALUE,&buf[9]);
	}
	
	if(Msg == WM_CLOSE)
	{
		EndDialog(hWndDlg,0);
	}
	
	if(Msg == WM_COMMAND)
	{
		if(LOWORD(wParam) == OK_ADD_CODE_NAME)
		{
			ccode code;
			memset(buf,' ',97);
			buf[98]=0;
			buf[0]='[';
			buf[1]='X';
			buf[2]=']';
			GetDlgItemText(hWndDlg,ADD_CODE_NAME,&buf[3],24);
			buf[strlen(buf)]=' ';
			
			
			GetDlgItemText(hWndDlg,ADD_CODE_CODE,&buf[28],25);
			if(load_ccode(&code,&buf[28]) < 3)
			{
				MessageBox(0,"Invald code","Error",0);
				return TRUE;
			}
			
			if((code.size > 4) || (code.size < 1))
			{
				MessageBox(0,"Code size must be between 1-4","Error",0);
				return TRUE;
			}
			
			save_ccode(&code,&buf[28]);
			SendMessage(GetDlgItem(codes_hwnd_tab,CODE_LIST),LB_ADDSTRING,0,(LPARAM)buf);
			EndDialog(hWndDlg,0);
		}
		
		if(LOWORD(wParam) == CANCEL_ADD_CODE_NAME)
		{
			EndDialog(hWndDlg,0);
		}
		
		if(LOWORD(wParam) == CANCEL_CREATE_CODE)
		{
			EndDialog(hWndDlg,0);
		}
		
		if(LOWORD(wParam) == OK_CREATE_CODE)
		{
			ccode code;
			GetDlgItemText(hWndDlg,CREATE_CODE_SIZE,buf,2);
			code.size=atoi(buf);
			if((code.size < 1)||(code.size > 4))
			{
				MessageBox(0,"Size must be between 1-4",buf,0);
				return TRUE;
			}
			
			GetDlgItemText(hWndDlg,CREATE_CODE_OFFSET,buf,9);
			code.offset=strtol(buf,0,16);
			GetDlgItemText(hWndDlg,CREATE_CODE_VALUE,buf,9);
			code.value=(atoi(buf) & (0xFFFFFFFF>>((4-code.size)*8)));
			
			memset(buf,' ',97);
			buf[98]=0;
			buf[0]='[';
			buf[1]='X';
			buf[2]=']';
			GetDlgItemText(hWndDlg,CREATE_CODE_NAME,&buf[3],24);
			buf[strlen(buf)]=' ';
			save_ccode(&code,&buf[28]);
			SendMessage(GetDlgItem(codes_hwnd_tab,CODE_LIST),LB_ADDSTRING,0,(LPARAM)buf);
			MessageBox(0,"Code Added!","SUCESS",0);
			EndDialog(hWndDlg,0);
		}
		
		return TRUE;
	}
	
	return FALSE;
}

int ___pt_eq_scan(void * a)
{
	fscan074_equal(&inject_074,SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_GETCURSEL,0,0)+1,atoi(buf),GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),scanner_hwnd_tab,SCAN_PERC,SCAN_COUNT);
	return 1;
}

int ___pt_unk_scan(void * a)
{
	fscan074_unknown(&inject_074,SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_GETCURSEL,0,0)+1,GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),scanner_hwnd_tab,SCAN_PERC,SCAN_COUNT);
	return 1;
}

int ___pt_ceq_scan(void * a)
{
	scan074_equal(&inject_074,SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_GETCURSEL,0,0)+1,atoi(buf),GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),scanner_hwnd_tab,SCAN_PERC,SCAN_COUNT);
	return 1;
}

int ___pt_cunc_scan(void * a)
{
	scan074_unchanged(&inject_074,SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_GETCURSEL,0,0)+1,GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),scanner_hwnd_tab,SCAN_PERC,SCAN_COUNT);
	return 1;
}

int ___pt_cchc_scan(void * a)
{
	scan074_changed(&inject_074,SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_GETCURSEL,0,0)+1,GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),scanner_hwnd_tab,SCAN_PERC,SCAN_COUNT);
	return 1;
}

int ___pt_cgtc_scan(void * a)
{
	scan074_greaterthan(&inject_074,SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_GETCURSEL,0,0)+1,atoi(buf),GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),scanner_hwnd_tab,SCAN_PERC,SCAN_COUNT);
	return 1;
}

int ___pt_cltc_scan(void * a)
{
	scan074_lessthan(&inject_074,SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_GETCURSEL,0,0)+1,atoi(buf),GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),scanner_hwnd_tab,SCAN_PERC,SCAN_COUNT);
	return 1;
}

int ___pt_cinc_scan(void * a)
{
	scan074_increased(&inject_074,SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_GETCURSEL,0,0)+1,GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),scanner_hwnd_tab,SCAN_PERC,SCAN_COUNT);
	return 1;
}

int ___pt_cdec_scan(void * a)
{
	scan074_decreased(&inject_074,SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_GETCURSEL,0,0)+1,GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),scanner_hwnd_tab,SCAN_PERC,SCAN_COUNT);
	return 1;
}

int __injector_thread(void * a)
{
	int i,c;
	char cuf[99];
	ccode bx;
	HWND hwnd = GetDlgItem(codes_hwnd_tab,CODE_LIST);
	for(;;)
	{
		if(attached)
		{
			c=SendMessage(hwnd,LB_GETCOUNT,0,0);
			for(i=0;i<c;++i)
			{
				SendMessage(hwnd,LB_GETTEXT,0,(LPARAM)cuf);
				if(cuf[1]=='O')
				{
					load_ccode(&bx,&cuf[28]);
					injectVal074(&inject_074,&bx);
				}
			}
		}
		Sleep(50);
	}
}

void SaveCodeList(HWND hwnd)
{
	char * fnbuf = malloc(MAX_PATH);
	fnbuf[0]=0;
	OPENFILENAME open;
	memset(&open,0,sizeof(OPENFILENAME));
	open.lStructSize = sizeof(OPENFILENAME);
    open.hwndOwner = hwnd;
    open.lpstrFilter = "All Files (*.*)\0*.*\0";
    open.lpstrFile = fnbuf;
    open.nMaxFile = MAX_PATH;
	open.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	open.lpstrTitle = "Save cheat-code list";
	
	HWND s_hwnd = GetDlgItem(codes_hwnd_tab,CODE_LIST);
	int c,i;
	char cuf[99];
	
	FILE * fp;
	if(GetSaveFileName(&open))
    {
		fp = fopen(fnbuf,"wb");
		c=SendMessage(s_hwnd,LB_GETCOUNT,0,0);
		
		for(i=0;i<c;++i)
		{
			SendMessage(s_hwnd,LB_GETTEXT,i,(LPARAM)cuf);
			fprintf(fp,"%s\n",&cuf[3]);
		}
		
		fclose(fp);
		MessageBox(0,"Saved!","SUCESS",0);
    }
	free(fnbuf);
}

void LoadCodeList(HWND hwnd)
{
	ccode bx;
	char * fnbuf = malloc(MAX_PATH);
	fnbuf[0]=0;
	OPENFILENAME open;
	memset(&open,0,sizeof(OPENFILENAME));
	open.lStructSize = sizeof(OPENFILENAME);
    open.hwndOwner = hwnd;
    open.lpstrFilter = "All Files (*.*)\0*.*\0";
    open.lpstrFile = fnbuf;
    open.nMaxFile = MAX_PATH;
	open.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	open.lpstrTitle = "Load cheat-code list";
	
	HWND s_hwnd = GetDlgItem(codes_hwnd_tab,CODE_LIST);
	char cuf[99];
	
	FILE * fp;
	if(GetSaveFileName(&open))
    {
		fp = fopen(fnbuf,"rb");
		while(!feof(fp))
		{
			cuf[0]='[';
			cuf[1]='X';
			cuf[2]=']';
			if(fscanf(fp,"%[^\t\n]\n",&cuf[3]))
			{
				if(!load_ccode(&bx,&cuf[28]))
				{
					if(!MessageBox(hwnd,"There appears to be corrupt codes.\nDo you want to continue loading?","Error",MB_YESNO))
					{
						break;
					}
				}
				SendMessage(s_hwnd,LB_ADDSTRING,0,(LPARAM)cuf);
			}
		}
		fclose(fp);
    }
	free(fnbuf);
}


LRESULT CALLBACK DlgProc(HWND hWndDlg, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	if(Msg == WM_INITDIALOG)
	{
		RECT rct;
		GetWindowRect(hWndDlg,&rct);
		SetWindowPos(hWndDlg,0,(GetSystemMetrics(SM_CXSCREEN)/2)-((rct.right-rct.left)/2),(GetSystemMetrics(SM_CYSCREEN)/2)-((rct.bottom-rct.top)/2),0,0,SWP_NOSIZE|SWP_NOZORDER);
	    SendMessage(hWndDlg, WM_SETICON, ICON_BIG  , (LPARAM)hIcon);
	    SendMessage(hWndDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIconSm);
		
		HWND tab_x = GetDlgItem(hWndDlg,SYS_TAB32);
		TCITEM ti;
		memset(&ti,0,sizeof(TCITEM));
		ti.mask = TCIF_TEXT;
		ti.pszText="DOSBox";
		SendMessage(tab_x,TCM_INSERTITEM,0,(LPARAM)&ti);
		ti.pszText="Scanner";
		SendMessage(tab_x,TCM_INSERTITEM,1,(LPARAM)&ti);
		ti.pszText="Codes";
		SendMessage(tab_x,TCM_INSERTITEM,2,(LPARAM)&ti);
		ti.pszText="Memory View";
		SendMessage(tab_x,TCM_INSERTITEM,3,(LPARAM)&ti);
		ti.pszText="About";
		SendMessage(tab_x,TCM_INSERTITEM,4,(LPARAM)&ti);
		
		if(!dosbox_hwnd_tab)
		{
			dosbox_hwnd_tab = hWndDlg;
			scanner_hwnd_tab = CreateDialog(hInstance,MAKEINTRESOURCE(2),0,(DLGPROC)DlgProc);
			codes_hwnd_tab = CreateDialog(hInstance,MAKEINTRESOURCE(3),0,(DLGPROC)DlgProc);
			memview_hwnd_tab = CreateDialog(hInstance,MAKEINTRESOURCE(4),0,(DLGPROC)DlgProc);
			about_hwnd_tab = CreateDialog(hInstance,MAKEINTRESOURCE(5),0,(DLGPROC)DlgProc);
			
			Disable(scanner_hwnd_tab,SCAN_EXACT_INIT);
			Disable(scanner_hwnd_tab,SCAN_UNKNOWN_INIT);
			Disable(scanner_hwnd_tab,SCAN_EXACT);
			Disable(scanner_hwnd_tab,SCAN_UNCHANGED);
			Disable(scanner_hwnd_tab,SCAN_CHANGED);
			Disable(scanner_hwnd_tab,SCAN_GREATER_THAN);
			Disable(scanner_hwnd_tab,SCAN_LESS_THAN);
			Disable(scanner_hwnd_tab,SCAN_INCREASED_THAN);
			Disable(scanner_hwnd_tab,SCAN_DECREASED_THAN);
			
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_ADDSTRING,0,(LPARAM)"1 Byte");
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_ADDSTRING,0,(LPARAM)"2 Byte");
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_ADDSTRING,0,(LPARAM)"3 Byte");
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_ADDSTRING,0,(LPARAM)"4 Byte");
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_DTYPE),CB_SETCURSEL,0,0);
		}
		
	}
	
	if(Msg == WM_NOTIFY)
	{
		static last_sel;
		if(LOWORD(wParam)==SYS_TAB32)
		{
			RECT rct;
			GetWindowRect(hWndDlg,&rct);
			int tabSel = SendDlgItemMessage(hWndDlg,SYS_TAB32,TCM_GETCURSEL,0,0);
			
			if(last_sel == tabSel){return FALSE;}
			last_sel = tabSel;
						
			if(tabSel == 0)
			{
				ShowWindow(dosbox_hwnd_tab,SW_SHOW);
				ShowWindow(hWndDlg,SW_HIDE);
				SetWindowPos(dosbox_hwnd_tab,HWND_TOP,rct.left,rct.top, 0, 0, SWP_NOSIZE);
				SendDlgItemMessage(dosbox_hwnd_tab,SYS_TAB32,TCM_SETCURSEL,0,0);
			}
			
			if(tabSel == 1)
			{
				ShowWindow(scanner_hwnd_tab,SW_SHOW);
				ShowWindow(hWndDlg,SW_HIDE);
				SetWindowPos(scanner_hwnd_tab,HWND_TOP,rct.left,rct.top, 0, 0, SWP_NOSIZE);
				SendDlgItemMessage(scanner_hwnd_tab,SYS_TAB32,TCM_SETCURSEL,1,0);
			}
			
			if(tabSel == 2)
			{
				ShowWindow(codes_hwnd_tab,SW_SHOW);
				ShowWindow(hWndDlg,SW_HIDE);
				SetWindowPos(codes_hwnd_tab,HWND_TOP,rct.left,rct.top, 0, 0, SWP_NOSIZE);
				SendDlgItemMessage(codes_hwnd_tab,SYS_TAB32,TCM_SETCURSEL,2,0);
			}
			
			if(tabSel == 3)
			{
				ShowWindow(memview_hwnd_tab,SW_SHOW);
				ShowWindow(hWndDlg,SW_HIDE);
				SetWindowPos(memview_hwnd_tab,HWND_TOP,rct.left,rct.top, 0, 0, SWP_NOSIZE);
				SendDlgItemMessage(memview_hwnd_tab,SYS_TAB32,TCM_SETCURSEL,3,0);
			}
			
			if(tabSel == 4)
			{
				ShowWindow(about_hwnd_tab,SW_SHOW);
				ShowWindow(hWndDlg,SW_HIDE);
				SetWindowPos(about_hwnd_tab,HWND_TOP,rct.left,rct.top, 0, 0, SWP_NOSIZE);
				SendDlgItemMessage(about_hwnd_tab,SYS_TAB32,TCM_SETCURSEL,4,0);
			}
		}
	}
	
	if(Msg == WM_CLOSE)
	{
		if(MessageBox(hWndDlg,"Are you sure you want to exit?","Confirm Exit",MB_YESNO) == IDYES)
		{
			_fcloseall();
			TempScanClean();
			PostQuitMessage(0);
			ExitProcess(0);
		}
	}
	
	if(Msg == WM_COMMAND)
	{
		if(LOWORD(wParam)==ATTACH_TO_DOSBOX_BTN)
		{
			attached = 0;
			if(!FindDOSBOX())
			{
				MessageBox(0,"Could not open DOSBox process","Error",0);
				return TRUE;
			}
			
			attached = 1;
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)__thread_update_info_074,0,0,0);
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)__injector_thread,0,0,0);
		}
		
		if(LOWORD(wParam)==ADD_CODE)
		{
			int added_code = DialogBox(hInstance, MAKEINTRESOURCE(6),hWndDlg,(DLGPROC)AddCodeDlgProc);
		}
		
		if(LOWORD(wParam)==DEL_CODE)
		{
			SendMessage(GetDlgItem(codes_hwnd_tab,CODE_LIST),LB_DELETESTRING,SendMessage(GetDlgItem(codes_hwnd_tab,CODE_LIST),LB_GETCARETINDEX,0,0),0);
		}
		
		if(LOWORD(wParam)==ACTIV_CODE)
		{
			ToggleCode(1);
		}
		
		if(LOWORD(wParam)==DEACTIV_CODE)
		{
			ToggleCode(0);
		}
		
		if(LOWORD(wParam)==REFRESH_MEM_VIEW)
		{
			GetDlgItemText(memview_hwnd_tab,PAGE_MEM_VIEW,buf,10);
			memview_page = atoi(buf);
			if(memview_page < 0){memview_page=0;}
			if(memview_page >= 0x1000){memview_page=0xFFF;}
			sprintf(buf,"%u",memview_page);
			SetDlgItemText(memview_hwnd_tab,PAGE_MEM_VIEW,buf);
			memview074(&inject_074,GetDlgItem(memview_hwnd_tab,MEM_VIEW),memview_page*0x1000,(memview_page+1)*0x1000);
		}
		
		if(LOWORD(wParam)==NEXT_MEM_VIEW)
		{
			GetDlgItemText(memview_hwnd_tab,PAGE_MEM_VIEW,buf,10);
			memview_page = atoi(buf);
			if(memview_page < 0){memview_page=0;}
			if(memview_page >= 0x1000){memview_page=0xFFF;}
			
			if(memview_page < 0xFFF)
			{
				++memview_page;
			}
			sprintf(buf,"%u",memview_page);
			SetDlgItemText(memview_hwnd_tab,PAGE_MEM_VIEW,buf);
			memview074(&inject_074,GetDlgItem(memview_hwnd_tab,MEM_VIEW),memview_page*0x1000,(memview_page+1)*0x1000);
		}
		
		if(LOWORD(wParam)==PREV_MEM_VIEW)
		{
			GetDlgItemText(memview_hwnd_tab,PAGE_MEM_VIEW,buf,10);
			memview_page = atoi(buf);
			if(memview_page < 0){memview_page=0;}
			if(memview_page >= 0x1000){memview_page=0xFFF;}
			
			if(memview_page > 0)
			{
				--memview_page;
			}
			sprintf(buf,"%u",memview_page);
			SetDlgItemText(memview_hwnd_tab,PAGE_MEM_VIEW,buf);
			memview074(&inject_074,GetDlgItem(memview_hwnd_tab,MEM_VIEW),memview_page*0x1000,(memview_page+1)*0x1000);
		}
		
		if(LOWORD(wParam)==NEW_SCAN)
		{
			if(scanning){return TRUE;}
			TempScanClean();
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),LB_RESETCONTENT,0,0);
			SetDlgItemText(scanner_hwnd_tab,SCAN_COUNT,"");
			Enable(scanner_hwnd_tab,SCAN_EXACT_INIT);
			Enable(scanner_hwnd_tab,SCAN_UNKNOWN_INIT);
			Enable(scanner_hwnd_tab,SCAN_DTYPE);
			Disable(scanner_hwnd_tab,SCAN_EXACT);
			Disable(scanner_hwnd_tab,SCAN_UNCHANGED);
			Disable(scanner_hwnd_tab,SCAN_CHANGED);
			Disable(scanner_hwnd_tab,SCAN_GREATER_THAN);
			Disable(scanner_hwnd_tab,SCAN_LESS_THAN);
			Disable(scanner_hwnd_tab,SCAN_INCREASED_THAN);
			Disable(scanner_hwnd_tab,SCAN_DECREASED_THAN);
		}
		
		if(LOWORD(wParam)==SCAN_EXACT_INIT)
		{
			if(scanning){return TRUE;}
			Disable(scanner_hwnd_tab,SCAN_EXACT_INIT);
			Disable(scanner_hwnd_tab,SCAN_UNKNOWN_INIT);
			Disable(scanner_hwnd_tab,SCAN_DTYPE);
			Enable(scanner_hwnd_tab,SCAN_EXACT);
			Enable(scanner_hwnd_tab,SCAN_UNCHANGED);
			Enable(scanner_hwnd_tab,SCAN_CHANGED);
			Enable(scanner_hwnd_tab,SCAN_GREATER_THAN);
			Enable(scanner_hwnd_tab,SCAN_LESS_THAN);
			Enable(scanner_hwnd_tab,SCAN_INCREASED_THAN);
			Enable(scanner_hwnd_tab,SCAN_DECREASED_THAN);
			
			GetDlgItemText(scanner_hwnd_tab,SCAN_EDITABLE,buf,10);
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),LB_RESETCONTENT,0,0);
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)___pt_eq_scan,0,0,0);
		}
		
		if(LOWORD(wParam)==SCAN_UNKNOWN_INIT)
		{
			if(scanning){return TRUE;}
			Disable(scanner_hwnd_tab,SCAN_EXACT_INIT);
			Disable(scanner_hwnd_tab,SCAN_UNKNOWN_INIT);
			Disable(scanner_hwnd_tab,SCAN_DTYPE);
			Enable(scanner_hwnd_tab,SCAN_EXACT);
			Enable(scanner_hwnd_tab,SCAN_UNCHANGED);
			Enable(scanner_hwnd_tab,SCAN_CHANGED);
			Enable(scanner_hwnd_tab,SCAN_GREATER_THAN);
			Enable(scanner_hwnd_tab,SCAN_LESS_THAN);
			Enable(scanner_hwnd_tab,SCAN_INCREASED_THAN);
			Enable(scanner_hwnd_tab,SCAN_DECREASED_THAN);
			GetDlgItemText(scanner_hwnd_tab,SCAN_EDITABLE,buf,10);
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),LB_RESETCONTENT,0,0);
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)___pt_unk_scan,0,0,0);
		}
		
		if(LOWORD(wParam)==SCAN_EXACT)
		{
			if(scanning){return TRUE;}
			GetDlgItemText(scanner_hwnd_tab,SCAN_EDITABLE,buf,10);
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),LB_RESETCONTENT,0,0);
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)___pt_ceq_scan,0,0,0);
		}
		
		if(LOWORD(wParam)==SCAN_UNCHANGED)
		{
			if(scanning){return TRUE;}
			GetDlgItemText(scanner_hwnd_tab,SCAN_EDITABLE,buf,10);
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),LB_RESETCONTENT,0,0);
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)___pt_cunc_scan,0,0,0);
		}
		
		if(LOWORD(wParam)==SCAN_CHANGED)
		{
			if(scanning){return TRUE;}
			GetDlgItemText(scanner_hwnd_tab,SCAN_EDITABLE,buf,10);
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),LB_RESETCONTENT,0,0);
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)___pt_cchc_scan,0,0,0);
		}
		
		if(LOWORD(wParam)==SCAN_GREATER_THAN)
		{
			if(scanning){return TRUE;}
			GetDlgItemText(scanner_hwnd_tab,SCAN_EDITABLE,buf,10);
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),LB_RESETCONTENT,0,0);
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)___pt_cgtc_scan,0,0,0);
		}
		
		if(LOWORD(wParam)==SCAN_LESS_THAN)
		{
			if(scanning){return TRUE;}
			GetDlgItemText(scanner_hwnd_tab,SCAN_EDITABLE,buf,10);
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),LB_RESETCONTENT,0,0);
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)___pt_cltc_scan,0,0,0);
		}
		
		if(LOWORD(wParam)==SCAN_INCREASED_THAN)
		{
			if(scanning){return TRUE;}
			GetDlgItemText(scanner_hwnd_tab,SCAN_EDITABLE,buf,10);
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),LB_RESETCONTENT,0,0);
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)___pt_cinc_scan,0,0,0);
		}
		
		if(LOWORD(wParam)==SCAN_DECREASED_THAN)
		{
			if(scanning){return TRUE;}
			GetDlgItemText(scanner_hwnd_tab,SCAN_EDITABLE,buf,10);
			SendMessage(GetDlgItem(scanner_hwnd_tab,SCAN_VIEW),LB_RESETCONTENT,0,0);
			CreateThread(0,0,(LPTHREAD_START_ROUTINE)___pt_cdec_scan,0,0,0);
		}
		
		if(LOWORD(wParam)==ADD_TO_CODELIST)
		{
			if(scanning){return TRUE;}
			DialogBox(hInstance, MAKEINTRESOURCE(7),0,(DLGPROC)AddCodeDlgProc);
		}
		
		if(LOWORD(wParam)==SAVE_F_CODE)
		{
			SaveCodeList(hWndDlg);
		}
		
		if(LOWORD(wParam)==OPEN_F_CODE)
		{
			LoadCodeList(hWndDlg);
		}
		
		return TRUE;
	}
	
	return FALSE;
}


int dosshark_main(void)
{
	TempScanClean();
	INITCOMMONCONTROLSEX icx;
	icx.dwSize=sizeof(icx);
	icx.dwICC=ICC_LISTVIEW_CLASSES|ICC_TAB_CLASSES;
	InitCommonControlsEx(&icx);

	hInstance = GetModuleHandle(0);
	hIcon = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(0), IMAGE_ICON, 32, 32, 0);
	hIconSm = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(0), IMAGE_ICON, 16, 16, 0);
	DialogBox(hInstance, MAKEINTRESOURCE(1),0,(DLGPROC)DlgProc);
}
